'MERCHANT CARD DIAL September-March
'Created by Peter Mayer 2007
'except where code from other authors is acknowledged.
'This program generates a card dial for the Southern Hemisphere Summer/
'Northern Hemisphere Winter.  It is based on the design of Charles J. Merchant
'as presented in Scientific American March, 1964, pp.136-139.
'Use the File:Set Print Region command
'to print the base, standard time dial and correction disk.

'portions of this code adapted from Equant dial program-author unknown
Const pi = 3.1415926535897932384626433832795028841971
Const minuspi = -3.1415926535897932384626433832795028841971
Const d2r = pi / 180	'degrees to radians factor
Const r2d = 180 / pi	'radian to degrees factor
Const e = 2.7182818284

Dim hours (19) As String	
Dim t As Double	'theta sun hour angle in degrees
Dim bm (13) As String
Dim datetext (13) As String
Dim eot (366) As Double
Dim cm, w As Double

Dim radius1 As Double
Dim count, degree, longitude, tick As Integer

Dim x,x0,x1,x2, test As Double
Dim oldx As Double

Dim y,y0,y1,y2 As Double
Dim oldy As Double


Const NumberofHours = 19	'sets number of hours on circular scale

'************
init_constants	'call the subroutine. Code in the sub-routine adapted from 
'the Circular Sundial Program of Valentin Hristov (valhrist@bas.bg)

'************



dcViewAll

dcAddLayer "CentreMark"	'put an X in the centre of the dial
dcSetCurrentLayer "CentreMark"	'make it the active layer
dcSetLineParms dcBLACK,dcSOLID,dcTHIN	'thin lines for the cross

dcCreateLine 0,.1,0,-.1
dcCreateLine -.1,0,.1,0

'*******
'Create Standard Time Dial
'*******

dcAddLayer "CircleDial"	'create a layer for the circular dial
dcSetCurrentLayer "CircleDial"	'make it the active layer
dcTurnLayerOff "CentreMark"
dcSetTextParms dcBlack,"Times New Roman","Normal",90,18,1,0,0
dcSetLineParms dcBLACK,dcSOLID,dcTHIN	'thin lines for the dial


dcSetCurrentLayer "CircleDial"	'switch to the new layer
radius1 = 3
dcCreateCircleEx 0,0,0,3,3,0,3,3	'draw outer arc
dcCreateCircleEx 0,0,0,.5,.5,0,.5,.5	'draw inner arc
For n = 1 To NumberofHours	'here we draw hour lines of the standard time dial
	
dcCreateLine .5,0,3,0
dcCreateText 2.75,0,0,hours(n)	'write the hours, while we're here

dcSelectAll	'now we turn everything counterclockwise by 15 degrees
dcSetSelectBase 0,0
dcRotateSelObjs 15
Next n

dcSelectAll
dcSetSelectBase 0,0
dcRotateSelObjs -45	'turn it so 12 o'clock is at the bottom


dcCreateCircle 0,0, 3.5	'draw the outer edge of standard dial

For M = 9 To 12	'spring
'step 1--draw left month divider
dcCreateLine 3,0,3.5,0
dcSelectAll
dcSetSelectBase 0,0
dcRotateSelObjs -5

'step 2--write last letter of month abbreviation plus tick for day 5
dcSetTextParms dcBlack,"Times New Roman","Normal",90,12,1,0,0
dcCreateText 3.05,0,0,Left (datetext(M), 1)
dcCreateLine 3.4,0,3.5,0
dcSelectAll
dcSetSelectBase 0,0
dcRotateSelObjs -5

'step 3--draw tick for day 10 plus label
dcSetTextParms dcBlack,"Times New Roman","Normal",90,9,1,0,0
dcCreateText 3.20,0,0,"10"
dcCreateLine 3.3,0,3.5,0
dcSelectAll
dcSetSelectBase 0,0
dcRotateSelObjs -5

'step 4--Write middle letter of month abbreviation plus tick
dcSetTextParms dcBlack,"Times New Roman","Normal",90,12,1,0,0
dcCreateText 3.05,0,0,Mid (datetext(M),2,1)
dcCreateLine 3.4,0,3.5,0
dcSelectAll
dcSetSelectBase 0,0
dcRotateSelObjs -5

'step 5--draw tick for day 20 plus tick
dcSetTextParms dcBlack,"Times New Roman","Normal",90,9,1,0,0
dcCreateText 3.20,0,0,"20"
dcCreateLine 3.3,0,3.5,0
dcSelectAll
dcSetSelectBase 0,0
dcRotateSelObjs -5

'step 6--Write first letter of month abbreviation plus tick
dcSetTextParms dcBlack,"Times New Roman","Normal",90,12,1,0,0
dcCreateText 3.05,0,0,Right (datetext(M),1)
dcCreateLine 3.4,0,3.5,0
dcSelectAll
dcSetSelectBase 0,0
dcRotateSelObjs -5


Next M

For M = 1 To 3	'Autumn
'step 1--draw left month divider
dcCreateLine 3,0,3.5,0
dcSelectAll
dcSetSelectBase 0,0
dcRotateSelObjs -5

'step 2--write last letter of month abbreviation plus tick for day 5
dcSetTextParms dcBlack,"Times New Roman","Normal",90,12,1,0,0
dcCreateText 3.05,0,0,Left (datetext(M), 1)
dcCreateLine 3.4,0,3.5,0
dcSelectAll
dcSetSelectBase 0,0
dcRotateSelObjs -5

'step 3--draw tick for day 10 plus label
dcSetTextParms dcBlack,"Times New Roman","Normal",90,9,1,0,0
dcCreateText 3.20,0,0,"10"
dcCreateLine 3.3,0,3.5,0
dcSelectAll
dcSetSelectBase 0,0
dcRotateSelObjs -5

'step 4--Write middle letter of month abbreviation plus tick
dcSetTextParms dcBlack,"Times New Roman","Normal",90,12,1,0,0
dcCreateText 3.05,0,0,Mid (datetext(M),2,1)
dcCreateLine 3.4,0,3.5,0
dcSelectAll
dcSetSelectBase 0,0
dcRotateSelObjs -5

'step 5--draw tick for day 20 plus tick
dcSetTextParms dcBlack,"Times New Roman","Normal",90,9,1,0,0
dcCreateText 3.20,0,0,"20"
dcCreateLine 3.3,0,3.5,0
dcSelectAll
dcSetSelectBase 0,0
dcRotateSelObjs -5

'step 6--Write first letter of month abbreviation plus tick
dcSetTextParms dcBlack,"Times New Roman","Normal",90,12,1,0,0
dcCreateText 3.05,0,0,Right (datetext(M),1)
dcCreateLine 3.4,0,3.5,0
dcSelectAll
dcSetSelectBase 0,0
dcRotateSelObjs -5


Next M


dcCreateLine 3.0,0,3.5,0	'draw final month line

dcSelectAll
dcSetSelectBase 0,0
dcRotateSelObjs 15	'turn it so 12 o'clock is at the bottom

dcSelectAll
dcGroupSelObjs "Standard_Time_Dial"
'dcUnselectCurrentObject



'********
'create the correction disk
'********

dcAddLayer "CorrectionDial"	'create a layer for the circular dial
dcSetCurrentLayer "CorrectionDial"
dcTurnLayerOff "CircleDial"	'for the moment turn the standard dial off
dcSetTextParms dcBlack,"Times New Roman","Normal",90,18,1,0,0

radius1 = 3.52
dcCreateCircle 0,0, radius1	'draw the correction dial


dcCreateCircle 0,0, 4.05	'draw the outer edge of standard dial

dcCreateLine 3.55,0,4.05,0	'draw Left Month divider

For M = 9 To 12	'spring
'Step 1--rotate for first tick
dcSelectAll
dcSetSelectBase 0,0
dcRotateSelObjs -5+(eot(bm(M)+4))'rotate the dial to correct for eot


'step 2--write last letter of month abbreviation plus tick for day 5
dcSetTextParms dcBlack,"Times New Roman","Normal",90,12,1,0,0
dcCreateText 3.85,0,0,Left (datetext(M), 1)
dcCreateLine 3.55,0,3.65,0
dcSelectAll
dcSetSelectBase 0,0
dcRotateSelObjs -(eot(bm(M)+4))-(5)+(eot(bm(M)+9))	'undue eot correction then do new one


'step 3--draw tick for day 10 plus label
dcSetTextParms dcBlack,"Times New Roman","Normal",90,9,1,0,0
dcCreateText 3.70,0,0,"10"
dcCreateLine 3.55,0,3.65,0
dcSelectAll
dcSetSelectBase 0,0
dcRotateSelObjs -(eot(bm(M)+9))-(5)+(eot(bm(M)+14))


'step 4--Write middle letter of month abbreviation plus tick
dcSetTextParms dcBlack,"Times New Roman","Normal",90,12,1,0,0
dcCreateText 3.85,0,0,Mid (datetext(M),2,1)
dcCreateLine 3.55,0,3.65,0
dcSelectAll
dcSetSelectBase 0,0
dcRotateSelObjs -(eot(bm(M)+14))-(5)+(eot(bm(M)+19))


'step 5--draw tick for day 20 plus tick
dcSetTextParms dcBlack,"Times New Roman","Normal",90,9,1,0,0
dcCreateText 3.70,0,0,"20"
dcCreateLine 3.55,0,3.65,0
dcSelectAll
dcSetSelectBase 0,0
dcRotateSelObjs -(eot(bm(M)+19))-(5)+(eot(bm(M)+24))


'step 6--Write first letter of month abbreviation plus tick
dcSetTextParms dcBlack,"Times New Roman","Normal",90,12,1,0,0
dcCreateText 3.85,0,0,Right (datetext(M),1)
dcCreateLine 3.55,0,3.65,0
dcSelectAll
dcSetSelectBase 0,0
dcRotateSelObjs -(eot(bm(M)+24))-(5)+(eot(bm(M+1)))
dcCreateLine 3.55,0,4.05,0	'end of month line. Gets drawn twice
dcSelectAll
dcSetSelectBase 0,0
dcRotateSelObjs -eot(bm(M+1))	'undo EoT


Next M

dcSelectAll
dcSetSelectBase 0,0
dcRotateSelObjs eot(bm(1))	'reset for January

dcCreateLine 3.55,0,4.05,0

For M = 1 To 3	'autumn
'step 1--draw left month divider
dcSelectAll
dcSetSelectBase 0,0
dcRotateSelObjs -5+(eot(bm(M)+4))'rotate the dial to correct for eot

'step 2--write last letter of month abbreviation plus tick for day 5
dcSetTextParms dcBlack,"Times New Roman","Normal",90,12,1,0,0
dcCreateText 3.85,0,0,Left (datetext(M), 1)
dcCreateLine 3.55,0,3.65,0
dcSelectAll
dcSetSelectBase 0,0
dcRotateSelObjs -(eot(bm(M)+4))-(5)+(eot(bm(M)+9))	'undue eot correction then do new one

'step 3--draw tick for day 10 plus label
dcSetTextParms dcBlack,"Times New Roman","Normal",90,9,1,0,0
dcCreateText 3.70,0,0,"10"
dcCreateLine 3.55,0,3.65,0
dcSelectAll
dcSetSelectBase 0,0
dcRotateSelObjs -(eot(bm(M)+9))-(5)+(eot(bm(M)+14))

'step 4--Write middle letter of month abbreviation plus tick
dcSetTextParms dcBlack,"Times New Roman","Normal",90,12,1,0,0
dcCreateText 3.85,0,0,Mid (datetext(M),2,1)
dcCreateLine 3.55,0,3.65,0
dcSelectAll
dcSetSelectBase 0,0
dcRotateSelObjs -(eot(bm(M)+14))-(5)+(eot(bm(M)+19))

'step 5--draw tick for day 20 plus tick
dcSetTextParms dcBlack,"Times New Roman","Normal",90,9,1,0,0
dcCreateText 3.70,0,0,"20"
dcCreateLine 3.55,0,3.65,0
dcSelectAll
dcSetSelectBase 0,0
dcRotateSelObjs -(eot(bm(M)+19))-(5)+(eot(bm(M)+24))

'step 6--Write first letter of month abbreviation plus tick
dcSetTextParms dcBlack,"Times New Roman","Normal",90,12,1,0,0
dcCreateText 3.85,0,0,Right (datetext(M),1)
dcCreateLine 3.55,0,3.65,0
dcSelectAll
dcSetSelectBase 0,0
dcRotateSelObjs -(eot(bm(M)+24))-(5)+(eot(bm(M+1)))
dcCreateLine 3.55,0,4.05,0	'end of month line. Gets drawn twice
dcSelectAll
dcSetSelectBase 0,0
dcRotateSelObjs -(eot(bm(M+1)))	'undo eot

Next M


dcSelectAll
dcGroupSelObjs "Correction_Dial"

dcSelectAll
dcSetSelectBase 0,0
dcRotateSelObjs 14	'turn it so zero correction is at 180 degrees (Sept1 = Sept1)

dcSelectAll
dcSetSelectBase 0,0
dcRotateSelObjs -155	'now turn it so we can start writing Longitude
'*******
'Longitude Correction	
'*******
'This writes Longitude corrections.  The dial is centred on Australia.

'step 1--Write first half of Longitude; this is crude, but I was in a hurry...

dcSetTextParms dcBlack,"Times New Roman","Normal",-90,18,1,0,0
dcCreateText 3.85,0,0,"L"
dcSelectAll
dcSetSelectBase 0,0
dcRotateSelObjs 5

dcCreateText 3.85,0,0,"O"
dcSelectAll
dcSetSelectBase 0,0
dcRotateSelObjs 5

dcCreateText 3.85,0,0,"N"
dcSelectAll
dcSetSelectBase 0,0
dcRotateSelObjs 5

dcCreateText 3.85,0,0,"G"
dcSelectAll
dcSetSelectBase 0,0
dcRotateSelObjs 5

dcCreateText 3.85,0,0,"I"
dcSelectAll
dcSetSelectBase 0,0
dcRotateSelObjs 5

dcCreateText 3.85,0,0,"-"
dcSelectAll
dcSetSelectBase 0,0
dcRotateSelObjs 10



'step 2--draw ticks plus labels for longitude
dcSetTextParms dcBlack,"Times New Roman","Normal",-90,18,1,0,0
longitude = 165
For longitude = 105 To 150 Step 15 
dcCreateText 3.85,0,0,longitude
dcCreateLine 3.9,0,4.05,0
dcSelectAll
dcSetSelectBase 0,0
dcRotateSelObjs 5
	For tick = 1 To 2
	dcCreateLine 3.95,0,4.05,0
	dcSelectAll
	dcSetSelectBase 0,0
	dcRotateSelObjs 5
	Next tick
Next longitude
dcCreateText 3.85,0,0,"165"	'last longitude
dcCreateLine 3.9,0,4.05,0
dcSelectAll
dcSetSelectBase 0,0

' step 3- complete the label
dcSetTextParms dcBlack,"Times New Roman","Normal",-90,18,1,0,0
dcSelectAll
dcSetSelectBase 0,0
dcRotateSelObjs 10


dcCreateText 3.85,0,0,"T"
dcSelectAll
dcSetSelectBase 0,0
dcRotateSelObjs 5

dcCreateText 3.85,0,0,"U"
dcSelectAll
dcSetSelectBase 0,0
dcRotateSelObjs 5

dcCreateText 3.85,0,0,"D"
dcSelectAll
dcSetSelectBase 0,0
dcRotateSelObjs 5

dcCreateText 3.85,0,0,"E"

'recentre the disk
dcSelectAll
dcSetSelectBase 0,0
dcRotateSelObjs 35



'*******
'Create Base
'*******

dcAddLayer "Base"	'create a base for the  dial
dcSetCurrentLayer "Base"	'make it the active layer
dcTurnLayerOff "CorrectionDial"	'for the moment turn the correction dial off
dcSetTextParms dcBlack,"Times New Roman","Normal",0,36,1,0,0
dcCreateText 0,5.8, 0,"MERCHANT DIAL"
dcSetTextParms dcBlack,"Times New Roman","Normal",0,8,1,0,0
dcCreateText -3.8,-4.8,0,"Peter Mayer Fecit Anno 2007"


dcSetTextParms dcBlack,"Times New Roman","Normal",90,18,1,0,0
dcSetLineParms dcBLACK,dcSOLID,dcTHIN	'thin lines for the outline

dcCreateLine -10, 5, 10,5	'draw top line of base
dcCreateLine -10, -5, 10,-5 'draw bottom line of base
dcCreateLine -10, 5, -10,-5	'draw left side
dcCreateLine 10,5,10,-5	'draw right side
dcSetLineParms dcBLACK,dcHIDDEN,dcTHIN	'dashed lines for the folds
dcCreateLine -5,5,-5,-5	'left fold
dcCreateText -5.3,0,0,"Fold here"
dcCreateLine 5,5,5,-5	'right fold
dcCreateText 5.2,0,0, "Fold here"


'******
'Create Standard Time Zone marks
'******

dcSelectAll
dcSetSelectBase 0,0
dcRotateSelObjs -105

dcSetTextParms dcBlack,"Times New Roman","Normal",-90,10,1,0,0
dcSetLineParms dcBLACK,dcARROW,dcTHIN	'Arrows for the ticks


dcCreateText 4.45,0,0,"WST"
dcCreateLine 4.05,0,4.25,0


dcSelectAll
dcSetSelectBase 0,0
dcRotateSelObjs 15


dcCreateText 4.45,0,0,"WDT"
dcCreateLine 4.05,0,4.25,0


dcSelectAll
dcSetSelectBase 0,0
dcRotateSelObjs 7.5	'To accommodate South Australia, on the half hour

dcCreateText 4.45,0,0,"CST"
dcCreateLine 4.05,0,4.25,0


dcSelectAll
dcSetSelectBase 0,0
dcRotateSelObjs 7.5	

dcCreateText 4.45,0,0,"EST"
dcCreateLine 4.05,0,4.25,0


dcSelectAll
dcSetSelectBase 0,0
dcRotateSelObjs 7.5	'To accommodate South Australia, on the half hour

dcCreateText 4.45,0,0,"CDT"
dcCreateLine 4.05,0,4.25,0


dcSelectAll
dcSetSelectBase 0,0
dcRotateSelObjs 7.5	

dcCreateText 4.45,0,0,"EDT"
dcCreateLine 4.05,0,4.25,0


dcSelectAll
dcSetSelectBase 0,0
dcRotateSelObjs 60
	're-align the base	


'******
'Create Latitude Scales--
'******

dcSetCircleParms dcBLACK,dcSOLID,dcTHIN
dcSetLineParms dcBLACK,dcSOLID,dcTHIN	'thin lines

'parameters for tick marks
x0=10
x1=9.65
x2=9.25
y0=5.0
y1=4.55
y2=4.15

'Set values for latitude scales-Left hand side, x is minus

For count=0 To -90 Step -2	'2 degree lines
test = Tan(d2r*count)*(-x0+5)-5	'Point-Slope Form of linear equation
	If test > y0 Then
	dcCreateLine -1*(y1+5)/(Tan (d2r*Abs(count)))-5,y1,-1*(y0+5)/(Tan (d2r*Abs(count)))-5,y0
	Else
	dcCreateLine -x1,Tan(d2r*count)*(-x1+5)-5,-x0,Tan(d2r*count)*(-x0+5)-5	
	End If
Next count

For count=0 To -90 Step -10	'10 degree lines
test = Tan(d2r*count)*(-x0+5)-5	'Point-Slope Form of linear equation
	If test > y0 Then
	dcCreateLine -1*(y2+5)/(Tan (d2r*Abs(count)))-5,y2,-1*(y0+5)/(Tan (d2r*Abs(count)))-5,y0
	dcSetTextParms dcBlack,"Times New Roman","Normal",0,24,1,0,0
	dcCreateText -1*(y2+5)/(Tan (d2r*Abs(count)))-5,y2-.25,0,Abs(count)
	
Else
	dcCreateLine -x2,Tan(d2r*count)*(-x2+5)-5,-x0,Tan(d2r*count)*(-x0+5)-5
	dcSetTextParms dcBlack,"Times New Roman","Normal",0,24,1,0,0
	dcCreateText -x2+.3,Tan(d2r*count)*(-x2+5)-4.85,0,Abs(count)
	
	End If
Next count

dcSetTextParms dcBlack,"Times New Roman","Normal",0,24,1,0,0
dcCreateText -7.5,2,0,"LATITUDE"

dcSetTextParms dcBlack,"Times New Roman","Normal",0,12,1,0,0
dcCreateText -6.2,-2.3,2.5,"Draw a straight line from this point to your latitude and cut"
dcSetLineParms dcBLACK,dcARROW,dcTHIN	'Arrows to point to corner
dcCreateLine -5.1,-4.9,-6.3,-2.8

'Set values for latitude scales-Right hand side
dcSetLineParms dcBLACK,dcSOLID,dcTHIN	'thin lines

For count=0 To 90 Step 2	'2 degree lines
test = Tan(d2r*count)*(x0-5)-5	'Point-Slope Form of linear equation
	If test > y0 Then
	dcCreateLine (y1+5)/(Tan (d2r*Abs(count)))+5,y1,(y0+5)/(Tan (d2r*Abs(count)))+5,y0
	Else
	dcCreateLine x1,Tan(d2r*count)*(x1-5)-5,x0,Tan(d2r*count)*(x0-5)-5	
	End If
Next count

For count=0 To 90 Step 10	'10 degree lines
test = Tan(d2r*count)*(x0-5)-5	'Point-Slope Form of linear equation
	If test > y0 Then
	dcCreateLine (y2+5)/(Tan (d2r*Abs(count)))+5,y2,(y0+5)/(Tan (d2r*Abs(count)))+5,y0
	dcSetTextParms dcBlack,"Times New Roman","Normal",0,24,1,0,0
	dcCreateText (y2+5)/(Tan (d2r*Abs(count)))+5,y2-.25,0,Abs(count)
	
Else
	dcCreateLine x2,Tan(d2r*count)*(x2-5)-5,x0,Tan(d2r*count)*(x0-5)-5
	dcSetTextParms dcBlack,"Times New Roman","Normal",0,24,1,0,0
	dcCreateText x2-.3,Tan(d2r*count)*(x2-5)-4.85,0,Abs(count)
	
	End If
Next count

dcSetTextParms dcBlack,"Times New Roman","Normal",0,24,1,0,0
dcCreateText 7.5,2,0,"LATITUDE"

dcSetTextParms dcBlack,"Times New Roman","Normal",0,12,1,0,0
dcCreateText 6.8,-2.3,2.5,"Draw a straight line from this point to your latitude and cut"
dcSetLineParms dcBLACK,dcARROW,dcTHIN	'Arrows to point to corner
dcCreateLine 5.1,-4.9,6.3,-2.8

dcTurnLayerOn "CircleDial"
dcTurnLayerOn "CentreMark"
dcTurnLayerOn "CorrectionDial"
dcUnSelectAll
dcViewAll
Beep

Sub init_constants  'this sub routine has been adapted from the Circular Sundial Program of
'Valentin Hristov (valhrist@bas.bg)
dm = 23.43954
dmr = dm*d2r

bm( 1)=  1 '1jan
bm( 2)= 32 '1feb
bm( 3)= 60
bm( 4)= 91
bm( 5)=121
bm( 6)=152
bm( 7)=182
bm( 8)=213
bm( 9)=244
bm(10)=274
bm(11)=305
bm(12)=335 '1dec
bm(13)=366 '1jan

hours( 1) = 9	'Southern Hemisphere summer hours
hours( 2) = 8
hours( 3) = 7
hours( 4) = 6
hours( 5) = 5
hours( 6) = 4
hours( 7) = 3
hours( 8) = 2
hours( 9) = 1
hours(10) = 12
hours(11) = 11
hours(12) = 10
hours(13) = 9
hours(14) = 8
hours(15) = 7
hours(16) = 6
hours(17) = 5
hours(18) = 4
hours(19) = 3



cm = 30 'Central Meridian of dial

For count=1 To 365
w=.017202792*(count-(cm-15)/360)
eot(count)=7.3656*Cos(w+1.4940)+9.9158*Cos(2*w+1.9230)+.3060*Cos(3*w-1.8081)+.2026*Cos(4*w+2.2525)
eot(count)=-eot(count)	'change sign= eot correction in minutes
eot(count)= eot(count)/4	'convert correction to degrees 
Next count
eot(366)=eot(1)

datetext( 1) = "JAN"
datetext( 2) = "FEB"
datetext( 3) = "MAR"
datetext( 4) = "APR"
datetext( 5) = "MAY"
datetext( 6) = "JUN"
datetext( 7) = "JUL"
datetext( 8) = "AUG"
datetext( 9) = "SEP"
datetext(10) = "OCT"
datetext(11) = "NOV"
datetext(12) = "DEC"
datetext(13) = "JAN"
End Sub
